import java.util.Stack;
import java.awt.event.*;
import java.awt.Color;
import javax.swing.SwingUtilities;


//Ce thread gre l'animation de la tortue pendant l'excution

public class Affichage extends Thread {
	static boolean execution_lancee=false; 
  boolean pause=false;
  private Cadre cadre;
  private StringBuffer instruction;
  private Souris souris=new Souris();
  Controleur_Memoire cm=null;
  public Affichage(){}
  public Affichage(Cadre cadre,StringBuffer instruction) {
    this.cadre=cadre;
    this.instruction=instruction;
  }
  class Souris extends MouseAdapter{  //Si on dplace les Scrollbar pendant le dessin
    public Souris(){}                 // Ceci permet d'interrompre momentanment l'excution
    public void mousePressed(MouseEvent e){
      pause=true;
    }
    public void mouseReleased(MouseEvent e){
      pause =false;
    }
  }
  public void run(){
    currentThread().setPriority(Thread.NORM_PRIORITY);
    SwingUtilities.invokeLater(new Runnable(){
    	public void run(){
    	    cadre.commande.setEditable(false); // la ligne de commandes n'est plus active    		
    	    cadre.commande.setBackground(new Color(250,232,217));
    	}
    });
    execution_lancee=true;
	cadre.ardoise1.active_souris(); // On active les vnements osuris sur la zone de dessin
    cadre.jScrollPane1.getVerticalScrollBar().addMouseListener(souris);
    cadre.jScrollPane1.getHorizontalScrollBar().addMouseListener(souris);
    try{
      cadre.touche.car=-1;
      cadre.error=false;
      monException.lance=false;
      Interprete.operande=Interprete.operateur=Interprete.drapeau_ouvrante=false;
      Interprete.instruction=new StringBuffer();
      Interprete.calcul=new Stack();
      Interprete.nom=new Stack();
      Interprete.locale=new Stack();
      Interprete.valeur=new Stack();
      Interprete.en_cours=new Stack();
      cm=new Controleur_Memoire(cadre);
      cm.start();
      String st=cadre.interprete.execute(instruction);
      if (!st.equals("")) throw new monException(cadre,Logo.messages.getString("que_faire")+" "+st+" ?");
    }
    catch(monException e){}
    SwingUtilities.invokeLater(new Runnable(){
    	public void run(){
    	    cadre.commande.setEditable(true);    		
    	    cadre.commande.setBackground(Color.WHITE);
    		cadre.commande.requestFocus();
    	}
    });
    execution_lancee=false;
    cm.continuer=false;
	cadre.error=false;
    monException.lance=false;
    cadre.jScrollPane1.getVerticalScrollBar().removeMouseListener(souris);
    cadre.jScrollPane1.getHorizontalScrollBar().removeMouseListener(souris);
	cadre.ardoise1.stop_souris(); //On arrte les listeners souris sur la zone de dessin
  }
  
  
  
}