import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.text.rtf.RTFEditorKit;
import javax.swing.text.*;
import java.io.*;
import java.lang.reflect.*;
//import Cadre.PopupListener;

public class PanneauHistorique extends JPanel {
	private ImageIcon ianimation=new ImageIcon(Editeur.dimensionne_image("animation.png",this));
	private JLabel label_animation=new JLabel(ianimation);
	private Color couleur_texte=Color.BLUE;
	private int taille_texte=12;
  JPanel jPanel1 = new JPanel();
  JButton bstop = new JButton();
  JButton bediteur = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  Historique historique = new Historique();
  DocumentLogoHistorique dsd;
  BorderLayout borderLayout1 = new BorderLayout();
  Cadre cadre;
  public PanneauHistorique(){}
  public PanneauHistorique(Cadre cadre) {
  	historique.setFont(Logo.police);
    this.cadre=cadre;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
	dsd=new DocumentLogoHistorique();
	historique.setDocument(dsd);
  }
  public Color getCouleurtexte(){
  	return couleur_texte;
  }
  public int police(){
  	return taille_texte;
  }
  class VideTexte implements Runnable{
  	public void run(){
  		historique.setText("");
  	}
  }
public void vide_texte(){
		SwingUtilities.invokeLater(new VideTexte());	
}
  void ecris(String sty,String texte){
 	try{
		int longueur=historique.getDocument().getLength();
		if (texte.length()>32000) throw new monException(cadre,Logo.messages.getString("chaine_trop_longue"));
		 		StringBuffer st=new StringBuffer(texte);
		 		if (longueur+texte.length()<65000){ 
		 			try{
		 				dsd.setStyle(sty);
		 				dsd.insertString(dsd.getLength(),texte,null);
		 				historique.setCaretPosition(dsd.getLength());
		 			}
		 			catch(BadLocationException e){}
		 		}
		 		else{
		 			vide_texte();
		}
	}
	catch(monException e2){}
 }
  private void jbInit() throws Exception {
    bstop.setToolTipText(Logo.messages.getString("interrompre_execution"));
    bstop.setText(Logo.messages.getString("stop"));
    bstop.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bstop_actionPerformed(e);
      }
    });
    bediteur.setToolTipText(Logo.messages.getString("ouvrir_editeur"));
    bediteur.setText(Logo.messages.getString("editeur"));
    bediteur.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bediteur_actionPerformed(e);
      }
    });
    this.setLayout(borderLayout1);
    bediteur.setMnemonic('E');
    this.setMinimumSize(new Dimension(4, 4));
    this.setPreferredSize(new Dimension(600, 40));
   historique.setForeground(Color.black);
   historique.setEditable(false);
    this.add(jPanel1,  BorderLayout.EAST);
    label_animation.setToolTipText(Logo.messages.getString("animation_active"));
    jPanel1.add(bediteur, null);
    jPanel1.add(bstop, null);
    this.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(historique, null);
  }

  void bediteur_actionPerformed(ActionEvent e) {
    if (!cadre.editeur.isVisible()) {
      for(int i=0;i<cadre.primitive.procedure.size();i++){
        Procedure procedure = ( (Procedure) cadre.primitive.procedure.get(i));
        if (procedure.affichable) {
          cadre.editeur.zonedition.ecris(Logo.messages.getString("pour") + " " + procedure.name);
          for (int j = 0; j < procedure.nbparametre; j++) {
            cadre.editeur.zonedition.ecris(" :" +
                                            procedure.variable.get(j).toString());
          }
          cadre.editeur.zonedition.ecris("\n" + procedure.instruction +
                                          Logo.messages.getString("fin") + "\n\n");
        }
      }
      cadre.editeur.setTitle(Logo.messages.getString("editeur"));
      cadre.editeur.setVisible(true);
      cadre.editeur.toFront();
      cadre.editeur.zonedition.requestFocus();
    }
    else {
      cadre.editeur.toFront();
			cadre.editeur.zonedition.requestFocus();
    }
  }
  public void active_animation(){
  	add(label_animation,BorderLayout.WEST);
  	validate();
  }
  public void stop_animation(){
  	remove(label_animation);
  	validate();
  }
  void bstop_actionPerformed(ActionEvent e) {
    monException.lance=true;
    cadre.error=true;
  }
  class Historique extends JTextPane implements ActionListener{
  	private JPopupMenu popup=new JPopupMenu();
	private JMenuItem jpopcopier = new JMenuItem();
	private JMenuItem jpopselect = new JMenuItem();
	private JMenuItem jpopsave = new JMenuItem();
  	Historique(){
  	//	this.setBackground(new Color(255,255,220));
  		popup.add(jpopcopier);
  		popup.add(jpopselect);
  		popup.add(jpopsave);
		jpopselect.addActionListener(this);
		jpopcopier.addActionListener(this);
		jpopsave.addActionListener(this);
		setText();
		MouseListener popupListener = new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				if (e.getButton()==1){
					int i=getCaretPosition();
					int borneinf=borne(i,-1);
					int bornesup=borne(i,1);
					if (borneinf==0) borneinf=borneinf-1;
					select(borneinf+1,bornesup-2);
					cadre.commande.setText(getSelectedText());
//				    historique.setCaretPosition(historique.getDocument().getLength());
					cadre.commande.requestFocus();}
			}
			public void mouseReleased(MouseEvent e) {
				maybeShowPopup(e);
				cadre.commande.requestFocus();
			}

			public void mousePressed(MouseEvent e) {
				maybeShowPopup(e);
			}

			private void maybeShowPopup(MouseEvent e) {
				if (e.isPopupTrigger()) {
					popup.show(e.getComponent(), e.getX(), e.getY());
				}	
			}		
		};
		addMouseListener(popupListener);
  	}
    int borne(int i,int increment){
        boolean continuer =true;
        while (continuer&&i!=0){
          select(i-1,i);
          String t=historique.getSelectedText();
          if (t.equals("\n")){
    	continuer=false;
          }
          i=i+increment;
        }
        return(i);
      }
  	void setText(){
		jpopselect.setText(Logo.messages.getString("tout_selectionner"));
		jpopcopier.setText(Logo.messages.getString("copier"));
		jpopsave.setText(Logo.messages.getString("enregistrer_rtf"));
		jpopselect.setActionCommand(Logo.messages.getString("tout_selectionner"));
		jpopcopier.setActionCommand(Logo.messages.getString("copier"));
		jpopsave.setActionCommand(Logo.messages.getString("enregistrer_rtf"));
  	}
  	public void actionPerformed(ActionEvent e){
  	    String cmd=e.getActionCommand();
  		if (Logo.messages.getString("copier").equals(cmd)){   //Copier
  	      copy();
  	    }
  	    else if (Logo.messages.getString("tout_selectionner").equals(cmd)){   //Selectionner tout
  	    	requestFocus();
  	    	selectAll();
  	    	cadre.commande.requestFocus();
  	     }
  	    else if (cmd.equals(Logo.messages.getString("enregistrer_rtf"))){
  	    	RTFEditorKit myRTFEditorKit = new RTFEditorKit();
  	    	StyledDocument myStyledDocument =getStyledDocument();
  	    	try{
  	          JFileChooser jf=new JFileChooser(LancePrimitive.SortieTexte(Logo.repertoire_defaut));
  	          jf.addChoosableFileFilter(new ExtensionFichier(Logo.messages.getString("fichiers_rtf"),".rtf"));
  	          MenuListener.recursivelySetFonts(jf,Logo.police);
  	          int retval=jf.showDialog(cadre,Logo.messages.getString("enregistrer"));
  	          if (retval==JFileChooser.APPROVE_OPTION){
  	          	String path=jf.getSelectedFile().getPath();
  	          	String path2=path.toLowerCase();  // on garde la casse du path pour les systmes d'exploitation faisant la diffrence
  	          	if (!path2.endsWith(".rtf")) path+=".rtf";
			  		FileOutputStream myFileOutputStream = new FileOutputStream(path);
	  	    		myRTFEditorKit.write(myFileOutputStream, myStyledDocument, 0,myStyledDocument.getLength()-1);
	  	    		myFileOutputStream.close();
	  	  
  	          }
  	    	}
  	    	catch(FileNotFoundException e1){}
  	    	catch(IOException e2){}
  	    	catch(BadLocationException e3){}
  	    	catch(NullPointerException e4){}
  	    }
  	}
  }
}
