import java.awt.Toolkit;
import java.awt.MediaTracker;
import java.awt.Polygon;
import java.awt.Color;
import java.awt.Image;
import java.awt.BasicStroke;
public class Tortue {	
  Color couleurcrayon=Color.black;
  Color couleurmodedessin=Color.black;
  int id=-1;
  BasicStroke crayon=null;
  int police=12;
  Image tort=null;  //image reprsentant la tortue
  double cap,corX,corY;
  double angle;
  boolean visible=true;
  Polygon triangle;
  int largeur=0,hauteur=0,gabarit=0;
  boolean baissecrayon=true;
  boolean inversecrayon=false;
  int forme=Logo.tortue_choisie;
  float taille_crayon=0; //moiti de la taille du crayon 
  public Tortue(Cadre cadre){
  	fixe_taille_crayon(1);
  	String chemin="tortue"+Logo.tortue_choisie+".png";
	if (Logo.tortue_choisie==0) {
		tort=null;
		largeur=26;
		hauteur=26;
	}
	else {
		//ON teste tout d'abord si le chemin est valide
		if (null==Tortue.class.getResource(chemin)) chemin="tortue1.png";
		tort = Toolkit.getDefaultToolkit().getImage(Tortue.class.getResource(chemin));
		MediaTracker tracker=new MediaTracker(cadre);
		tracker.addImage(tort,0);
		try{tracker.waitForID(0);}
		catch(InterruptedException e1){}
		largeur = tort.getWidth(cadre);
		hauteur = tort.getHeight(cadre);
		double largeur_ecran=Toolkit.getDefaultToolkit().getScreenSize().getWidth(); 
		// On fait attention  la rsolution de l'utilisateur
		double facteur = largeur_ecran/1024.0;
		if ((int)(facteur+0.001)!=1){
			tort=tort.getScaledInstance((int)(facteur*largeur),(int)(facteur*hauteur),Image.SCALE_SMOOTH);
			tracker=new MediaTracker(cadre);
			tracker.addImage(tort,0);
			try{tracker.waitForID(0);}
			catch(InterruptedException e1){}
		}
		largeur = tort.getWidth(cadre);
		hauteur = tort.getHeight(cadre);
	}
	gabarit = Math.max(hauteur, largeur);
    corX=Logo.largeur_dessin/2;
    corY=Logo.hauteur_dessin/2;
    angle=Math.PI/2;
    cap=0.0;
  }
  void init(){
  corX=Logo.largeur_dessin/2;
  corY=Logo.hauteur_dessin/2;
  cap=0.0;
  angle=Math.PI/2;
  baissecrayon=true;
  }

  void coord(){
    if (null == tort) {
          int[] abs = { (int) (corX - 10.0 * Math.sin(angle)),
          (int) (corX + 24.0 * Math.cos(angle)),
          (int) (corX + 10.0 * Math.sin(angle))};
      int[] ord = {
           (int) (corY - 10.0 * Math.cos(angle)),
          (int) (corY - 24.0 * Math.sin(angle)),
          (int) (corY + 10.0 * Math.cos(angle))};
      triangle = new Polygon(abs, ord, 3);
    }
  }
  void fixe_taille_crayon(float nb){
  	if (nb<0) nb=1;
  	else if (Logo.epaisseur_max!=-1&&nb>Logo.epaisseur_max) nb=1;
	if (Logo.forme_crayon==0) crayon=new BasicStroke(nb,BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
	else crayon=new BasicStroke(nb,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER);
	taille_crayon=(int) (nb / 2);

  }
}
